/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.common.action;

import java.util.Date;

import jp.mosp.common.bean.AuthBean;
import jp.mosp.common.common.BaseAction;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.LogUtility;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.dto.CmAspUserDto;
import jp.mosp.common.vo.LoginVo;

/**
 * MosPフレームワーク標準の認証機能を提供する。<br><br>
 * パスワードによる認証の他、ログイン試行回数や時間による
 * アカウント管理を行う。
 */
public class AuthAction extends BaseAction {
	
	/**
	 * コンストラクタ。<br>
	 * 以下の設定を行う。<br>
	 * <ul>
	 * <li>セッション確認不要    </li>
	 * <li>ASPユーザー確認不要   </li>
	 * <li>ユーザー確認不要      </li>
	 * <li>権限確認不要          </li>
	 * <li>処理シーケンス確認不要</li>
	 * </ul>
	 */
	public AuthAction() {
		super();
		setNeedSession (false);
		setNeedAspUser (false);
		setNeedUser    (false);
		setCheckAuth   (false);
		setCheckProcSeq(false);
	}
	
	/**
	 * アクション。<br>
	 * 認証処理{@link #login(BaseVo)}を実行する。
	 */
	public void action() throws Exception {
		// VOの準備
		BaseVo vo = getInitVo();
		// VO及び遷移先をセット(認証成功時に上書する)
		setVo(vo);
		setUrl(vo.getRetUrl());
		// DB接続先の設定
		createAspUser();
		// 認証処理
		login(vo);
		// 次コマンド設定
		setNextPage(vo);
		// ユーザー情報設定
		setUserField();
		// ユーザー情報保存
		storeUserInfo();
		// ログ出力
		LogUtility.log(request, 4, MospConst.LOG_MOSPINF, MospConst.LOG_MSG_LOGIN);
	}
	
	
	/**
	 * 認証処理。<br>
	 * パスワードによる認証、及びアカウント管理を行う。
	 * @param baseVo ログイン画面のVO
	 */
	protected void login(BaseVo baseVo) throws Exception {
		// VO準備
		chkInstance(baseVo instanceof LoginVo);
		LoginVo vo = (LoginVo)baseVo;
		// パラメータの取得
		vo.setParams(request);
		// パラメータの妥当性確認
		vo.validate();
		// DBコネクションの取得
		getConnection();
		// 認証処理
		AuthBean authBean = new AuthBean(cfg, cmd, aspUser, conn, hasMospSeJar());
		authBean.login(vo.getUserId(), vo.getPass());
		// 認証が失敗している場合
		if (authBean.isErrMessage()) {
			// コミット
			commit();
			// エラーメッセージの設定
			vo.addErrMessage(MospUtility.getMessage(msg, authBean.getErrMessageCode(), ""));
			throw new MospException(authBean.getMosPExceptionCode());
		}
		this.user = authBean.getCmUserDto();
	}
	
	/**
	 * 次ページ遷移処理
	 * @param vo 対象VO
	 * @throws Exception
	 */
	@SuppressWarnings("unused")
	protected void setNextPage(BaseVo vo) throws Exception {
		// 初期コマンド設定
		String nextCmd = MospConst.CMD_MENU;
		// パスワード有効期限確認
		int passTerm = getPasswordTerm();
		// パスワード有効期限を過ぎていたら、パスワード変更画面に遷移する。
		if (isExpirePassWord(passTerm, user.getChangePass())) {
			nextCmd = MospConst.CMD_PASS_FORCE;
		}
		// ユーザーIDとパスワードが同じ場合、パスワード変更画面に遷移する。
		if (isDefaultPassWord(user.getUserId(), user.getPassword())) {
			nextCmd = MospConst.CMD_PASS_FORCE;
		}
		// 次コマンド設定
		setNextCmd(nextCmd);
		// サーブレットへ
		setUrl(MospConst.URL_SRV);
	}
	
	/**
	 * パスワード有効期限日数取得。<br>
	 * @return	int パスワード有効期限日数
	 * @throws Exception
	 */
	protected int getPasswordTerm() throws Exception {
		// 設定ファイルから取得
		String days = cfg.getProperty(MospConst.PPT_ACC_VALIDITY);
		// 未設定の場合はintの最大値
		if (days == null) {
			return Integer.MAX_VALUE;
		}
		return Integer.parseInt(days);
	}
	
	/**
	 * パスワード有効期限チェック。<br>
	 * @param passTerm   有効期限期間
	 * @param updateDate 更新日時
	 * @return
	 * <p>
	 * 有効期限を超過したらtrue、そうでない場合false
	 * </p>
	 */
	private boolean isExpirePassWord(int passTerm, Date updateDate) {
		if (passTerm > 0 && MospUtility.getSystemDate().
				compareTo(MospUtility.addDay(updateDate, passTerm)) > 0) {
			return true;
		}
		return false;
	}

	/**
	 * デフォルトパスワードチェック。<br>
	 * @param userid        対象ユーザID
	 * @param inputPassWord	 対象パスワード
	 * @return
	 * <p>
	 * デフォルトパスワードの場合true、そうでない場合false
	 * </p>
	 * @throws Exception
	 */
	private boolean isDefaultPassWord(String userid, String passWord) throws Exception {
		if (MospUtility.encrypt(MospUtility.getDigest(userid), hasMospSeJar()).equals(passWord)) {
			return true;
		}
		return false;
	}
	
	/**
	 * VO取得。<br>
	 * {@link BaseVo}を拡張したVOを準備する。<br>
	 * @return VOインスタンス
	 */
	protected BaseVo getInitVo() {
		return new LoginVo(cfg, msg, nam, cmd, aspUser, user);
	}
	
	/**
	 * CmAspUserDtoの生成。<br>
	 * mosp.propertiesの設定によって、DB接続先を取得、設定する。<br>
	 */
	protected void createAspUser() {
		aspUser = new CmAspUserDto();
		aspUser.setAspUserId(cfg.getProperty(MospConst.PPT_ASP_ASPUSER ));
		aspUser.setAspName  (cfg.getProperty(MospConst.PPT_ASP_ASPNAME ));
		aspUser.setDbDriver (cfg.getProperty(MospConst.PPT_ASP_DBDRIVER));
		aspUser.setDbUrl    (cfg.getProperty(MospConst.PPT_ASP_DBURL   ));
		aspUser.setDbUser   (cfg.getProperty(MospConst.PPT_ASP_DBUSER  ));
		aspUser.setDbPass   (cfg.getProperty(MospConst.PPT_ASP_DBPASS  ));
	}
	
	/**
	 * ユーザー情報の設定。<br>
	 * 認証に成功したユーザーに、各種情報を設定する。<br>
	 */
	protected void setUserField() {
		// ユーザー情報を設定
		user.setPassword("");
	}
	
	/**
	 * ユーザー情報の保存。<br>
	 * 認証に成功したユーザー情報をセッションに設定する。<br>
	 */
	protected void storeUserInfo() {
		// セッションの再取得
		if (session != null) {
			session.invalidate();
		}
		session = request.getSession(true);
		// ユーザー情報を設定
		session.setAttribute(MospConst.ATT_ASPUSER, aspUser);
		session.setAttribute(MospConst.ATT_USER, user);
		request.setAttribute(MospConst.ATT_USER, user);
	}
	
}
